$INCLUDE "RAPIDQ.INC"
'--- Declarations ---
' possible translation to Rapidq:

' INIT FILE wmiinfo.bas

' wmiinfo.dll is a Dynamic Linked Library written by me,
' John White, for myself and any programming language that
' can utilize it.

' Purpose: To retreive WMI (BIOS, CPU, Etc) Informaton.

' Website: http://www.yoingco.com/
'   Email: john@yoingco.com

' Tested   on:  Windows XP (SP2) Home Edition (Genuine).
'        Date:  20th September 2006.

$TYPECHECK ON

$IFNDEF False
   $DEFINE False 0
$ENDIF

$IFNDEF True
   $DEFINE True 1
$ENDIF

CONST cr = CHR$(13)

TYPE BIOSInfo
   smMajorVersion       AS LONG
   smMinorVersion       AS LONG
   primaryBIOS          AS LONG
   softwareElementState AS LONG
   targetOS             AS LONG
   caption              AS LONG
   description          AS LONG
   manufacturer         AS LONG
   nname                AS LONG
   serialNumber         AS LONG
   status               AS LONG
   version              AS LONG
   smVersion            AS LONG
END TYPE

TYPE CPUInfo
   currentClockSpeed      AS LONG
   maxClockSpeed          AS LONG
   addressWidth           AS LONG
   architecture           AS LONG
   availability           AS LONG
   cpuStatus              AS LONG
   dataWidth              AS LONG
   extClock               AS LONG
   family                 AS LONG
   level                  AS LONG
   loadPercentage         AS LONG
   processorType          AS LONG
   revision               AS LONG
   statusInfo             AS LONG
   upgradeMethod          AS LONG
   caption                AS LONG
   deviceID               AS LONG
   manufacturer           AS LONG
   nname                  AS LONG
   otherFamilyDescription AS LONG
   role                   AS LONG
   socketDesignation      AS LONG
   status                 AS LONG
   stepping               AS LONG
   version                AS LONG
END TYPE

TYPE OSInfo
   currentTimeZone  AS LONG
   numberOfUsers    AS LONG
   osLanguage       AS LONG
   osType           AS LONG
   primary          AS LONG
   spMajorVersion   AS LONG
   spMinorVersion   AS LONG
   bootDevice       AS LONG
   buildNumber      AS LONG
   buildType        AS LONG
   caption          AS LONG
   codeSet          AS LONG
   countryCode      AS LONG
   description      AS LONG
   locale           AS LONG
   manufacturer     AS LONG
   nname            AS LONG
   organization     AS LONG
   registeredUser   AS LONG
   serialNumber     AS LONG
   status           AS LONG
   systemDevice     AS LONG
   systemDirectory  AS LONG
   systemDrive      AS LONG
   version          AS LONG
   windowsDirectory AS LONG
END TYPE

DECLARE FUNCTION Get_BIOSInfo _
        LIB "wmiinfo.dll" _
        ALIAS "Get_BIOSInfo" _
       (lpBIOSInfo AS BIOSInfo) AS LONG

DECLARE FUNCTION Get_CPUInfo _
        LIB "wmiinfo.dll" _
        ALIAS "Get_CPUInfo" _
       (lpCPUInfo AS CPUInfo) AS LONG

DECLARE FUNCTION Get_OSInfo _
        LIB "wmiinfo.dll" _
        ALIAS "Get_OSInfo" _
       (lpOSInfo AS OSInfo) AS LONG

DIM rtn AS LONG, Info AS STRING
DIM tBIOSInfo AS BIOSInfo
DIM tCPUInfo  AS CPUInfo
DIM tOSInfo   AS OSInfo
' ------------------------------------------------------------------------------
rtn = Get_BIOSInfo(tBIOSInfo)

Info = "********** BIOS Info **********" & cr & cr & _
       "Primary BIOS: " & IIF(tBIOSInfo.primaryBIOS = False, "NO", "YES") & cr & _
       "Caption: " & VARPTR$(tBIOSInfo.caption) & cr & _
       "Description: " & VARPTR$(tBIOSInfo.description) & cr & _
       "Manufacturer: " & VARPTR$(tBIOSInfo.manufacturer) & cr & _
       "Name: " & VARPTR$(tBIOSInfo.nname) & cr & _
       "Serial Number: " & VARPTR$(tBIOSInfo.serialNumber) & cr & _
       "Status: " & VARPTR$(tBIOSInfo.status) & cr & _
       "Version: " & VARPTR$(tBIOSInfo.version) & cr & _
       "SMBIOS Version: " & VARPTR$(tBIOSInfo.smVersion) & cr & _
       "SMBIOS Major Version: " & STR$(tBIOSInfo.smMajorVersion) & cr & _
       "SMBIOS Minor Version: " & STR$(tBIOSInfo.smMinorVersion) & cr & _
       "Software Element State: " & STR$(tBIOSInfo.softwareElementState) & cr & _
       "Target Operating System: " & STR$(tBIOSInfo.targetOS)

ShowMessage Info
' ------------------------------------------------------------------------------
rtn = Get_CPUInfo(tCPUInfo)

Info = "********** CPU Info **********" & cr & cr & _
       "Address Width: " & STR$(tCPUInfo.addressWidth) & cr & _
       "Architecture: " & STR$(tCPUInfo.architecture) & cr & _
       "Availability: " & STR$(tCPUInfo.availability) & cr & _
       "Current Clock Speed: " & STR$(tCPUInfo.currentClockSpeed) & cr & _
       "CPU Status: " & STR$(tCPUInfo.cpuStatus) & cr & _
       "Data Width: " & STR$(tCPUInfo.dataWidth) & cr & _
       "External Clock Frequency: " & STR$(tCPUInfo.extClock) & cr & _
       "Family: " & STR$(tCPUInfo.family) & cr & _
       "Level: " & STR$(tCPUInfo.level) & cr & _
       "Load Percentage: " & STR$(tCPUInfo.loadPercentage) & cr & _
       "Maximum Clock Speed: " & STR$(tCPUInfo.maxClockSpeed) & cr & _
       "Processor Type: " & STR$(tCPUInfo.processorType) & cr & _
       "Revision: " & STR$(tCPUInfo.revision) & cr & _
       "Status Info: " & STR$(tCPUInfo.statusInfo) & cr & _
       "Upgrade Method: " & STR$(tCPUInfo.upgradeMethod) & cr & _
       "Caption: " & VARPTR$(tCPUInfo.caption) & cr & _
       "DeviceID: " & VARPTR$(tCPUInfo.deviceID) & cr & _
       "Manufacturer: " & VARPTR$(tCPUInfo.manufacturer) & cr & _
       "Name: " & VARPTR$(tCPUInfo.nname) & cr & _
       "Other Family Description: " & VARPTR$(tCPUInfo.otherFamilyDescription) & cr & _
       "Role: " & VARPTR$(tCPUInfo.role) & cr & _
       "Socket Designation: " & VARPTR$(tCPUInfo.socketDesignation) & cr & _
       "Status: " & VARPTR$(tCPUInfo.status) & cr & _
       "Stepping: " & VARPTR$(tCPUInfo.stepping) & cr & _
       "Version: " & VARPTR$(tCPUInfo.version)
ShowMessage Info
' ------------------------------------------------------------------------------
rtn = Get_OSInfo(tOSInfo)

Info = "********** OS Info **********" & cr & cr & _
       "Current Time Zone: " & STR$(tOSInfo.currentTimeZone) & cr & _  ' Will be 60 if 1 hour daylight saving time is on.
       "Number Of Users: " & STR$(tOSInfo.numberOfUsers) & cr & _      ' 2 = You and the Administrator.
       "OS Language: " & STR$(tOSInfo.osLanguage) & cr & _
       "OS Type: " & STR$(tOSInfo.osType) & cr & _
       "Primary OS: " & IIF(tOSInfo.primary = False, "NO", "YES") & cr & _
       "Service Pack Major Version: " & STR$(tOSInfo.spMajorVersion) & cr & _
       "Service Pack Minor Version: " & STR$(tOSInfo.spMinorVersion) & cr & _
       "Boot Device: " & VARPTR$(tOSInfo.bootDevice) & cr & _
       "Build Number: " & VARPTR$(tOSInfo.buildNumber) & cr & _
       "Build Type: " & VARPTR$(tOSInfo.buildType) & cr & _
       "Caption: " & VARPTR$(tOSInfo.caption) & cr & _
       "Code Set: " & VARPTR$(tOSInfo.codeSet) & cr & _
       "Country Code: " & VARPTR$(tOSInfo.countryCode) & cr & _
       "Description: " & VARPTR$(tOSInfo.description) & cr & _
       "Locale: " & VARPTR$(tOSInfo.locale) & cr & _
       "Manufacturer: " & VARPTR$(tOSInfo.manufacturer) & cr & _
       "Name: " & VARPTR$(tOSInfo.nname) & cr & _
       "Organization: " & VARPTR$(tOSInfo.organization) & cr & _
       "Registered User: " & VARPTR$(tOSInfo.registeredUser) & cr & _
       "Serial Number: " & VARPTR$(tOSInfo.serialNumber) & cr & _
       "Status: " & VARPTR$(tOSInfo.status) & cr & _
       "System Device: " & VARPTR$(tOSInfo.systemDevice) & cr & _
       "System Directory: " & VARPTR$(tOSInfo.systemDirectory) & cr & _
       "System Drive: " & VARPTR$(tOSInfo.systemDrive) & cr & _
       "Version: " & VARPTR$(tOSInfo.version) & cr & _
       "Windows Directory: " & VARPTR$(tOSInfo.windowsDirectory)
ShowMessage Info

' END FILE wmiinfo.bas

